from guided_mrmp.conflict_resolvers.local_resolver import LocalResolver
from guided_mrmp.conflict_resolvers.subproblems import SubproblemPlacer
from .query import QueryDatabase

class DBResolver(LocalResolver):
    def __init__(self, conflicts, all_robots, dt, grid):
        """
        inputs:
            - conflicts (list): list of all conflicts
            - all_robots (list): list of all robots
            - dt (float): time step
        """
        super().__init__(conflicts, all_robots, dt)
        self.grid = grid # obstacle map

    def convert_solution_to_local_controls(self, solution):
        raise NotImplementedError


    def get_local_controls(self):
        controls = []
        for c in self.conflicts:
            # create a subproblem for each conflict
            sp = SubproblemPlacer(self.all_robots, self.grid, c)
            subproblem = sp.place_subproblem()

            # solve the subproblem
            query_db = QueryDatabase()
            solution = query_db.query(subproblem)

            # get the local controls
            controls = self.convert_solution_to_local_controls(solution)

            controls.append(controls)
        return controls

