"""
ConflictResolver is a local database conflict resolution strategy that resolves 
conflicts in the continuous space by creating a discrete local subprblem
and solving that subproblem via a query to an exhaustive database of solutions 
"""

import matplotlib.pyplot as plt

class LocalResolver:

    def __init__(self, conflicts, all_robots, dt):
        """
        inputs:
            - conflicts (list): list of all conflicts
            - all_robots (list): list of all robots
            - dt (float): time step
        """
        self.conflicts = conflicts
        self.all_robots = all_robots
        self.dt = dt
        

    def get_local_controls():
        """
        This function will return the local controls for the robots in conflict.
        It should be implemented by the child classes.
        """
        raise NotImplementedError
